Ogre::GLHardwareOcclusionQuery Class Reference

This is a class that is the base class of the query class for hardware occlusion. More...

`#include <OgreGLHardwareOcclusionQuery.h>`

Inheritance diagram for Ogre::GLHardwareOcclusionQuery:
[legend]

List of all members.

## Public Member Functions

| GLHardwareOcclusionQuery ()
| Default object constructor.
| ~GLHardwareOcclusionQuery ()
| Object destructor.
void | beginOcclusionQuery ()
| Starts the hardware occlusion query.
void | endOcclusionQuery ()
| Ends the hardware occlusion test.
bool | pullOcclusionQuery (unsigned int *NumOfFragments)
| Pulls the hardware occlusion query.
bool | isStillOutstanding (void)
| Lets you know when query is done, or still be processed by the Hardware.
unsigned int | getLastQuerysPixelcount () const
| Let's you get the last pixel count with out doing the hardware occlusion test.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Protected Attributes

unsigned int | mPixelCount
bool | mIsQueryResultStillOutstanding

## Private Attributes

GLuint | mQueryID

## Detailed Description

This is a class that is the base class of the query class for hardware occlusion.

Author:
  Lee Sandberg email: lee@abcmedia.se Updated on 13/9/2005 by Tuan Kuranes email: tuan.kuranes@free.fr

Definition at line 72 of file OgreGLHardwareOcclusionQuery.h.

## Constructor & Destructor Documentation

Ogre::GLHardwareOcclusionQuery::GLHardwareOcclusionQuery | ( |  | ) |

Default object constructor.

Ogre::GLHardwareOcclusionQuery::~GLHardwareOcclusionQuery | ( |  | ) |

Object destructor.

## Member Function Documentation

void Ogre::GLHardwareOcclusionQuery::beginOcclusionQuery | ( |  | ) | `[virtual]`

Starts the hardware occlusion query.

Remarks:
  Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* mOcclusionQuery; createOcclusionQuery( &mOcclusionQuery ); In the rendering loop: Draw all occluders mOcclusionQuery->startOcclusionQuery(); Draw the polygons to be tested mOcclusionQuery->endOcclusionQuery();

Results must be pulled using: UINT mNumberOfPixelsVisable; pullOcclusionQuery( &mNumberOfPixelsVisable );

Implements Ogre::HardwareOcclusionQuery.

void Ogre::GLHardwareOcclusionQuery::endOcclusionQuery | ( |  | ) | `[virtual]`

Ends the hardware occlusion test.

Implements Ogre::HardwareOcclusionQuery.

unsigned int Ogre::HardwareOcclusionQuery::getLastQuerysPixelcount | ( |  | ) | const`[inherited]`

Let's you get the last pixel count with out doing the hardware occlusion test.

Returns:
  The last fragment count from the last test. Remarks This function won't give you new values, just the old value.

Definition at line 109 of file OgreHardwareOcclusionQuery.h.

bool Ogre::GLHardwareOcclusionQuery::isStillOutstanding | ( | void |  | ) | `[virtual]`

Lets you know when query is done, or still be processed by the Hardware.

Returns:
  true if query isn't finished.

Implements Ogre::HardwareOcclusionQuery.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

bool Ogre::GLHardwareOcclusionQuery::pullOcclusionQuery | ( | unsigned int * | NumOfFragments | ) | `[virtual]`

Pulls the hardware occlusion query.

Note:
  Waits until the query result is available; use isStillOutstanding if just want to test if the result is available.

Return values:

  NumOfFragments | will get the resulting number of fragments.

Returns:
  True if success or false if not.

Implements Ogre::HardwareOcclusionQuery.

## Member Data Documentation

bool Ogre::HardwareOcclusionQuery::mIsQueryResultStillOutstanding`[protected, inherited]`

Definition at line 125 of file OgreHardwareOcclusionQuery.h.

unsigned int Ogre::HardwareOcclusionQuery::mPixelCount`[protected, inherited]`

Definition at line 123 of file OgreHardwareOcclusionQuery.h.

Referenced by Ogre::D3D11HardwareOcclusionQuery::getLastQuerysPixelcount().

GLuint Ogre::GLHardwareOcclusionQuery::mQueryID`[private]`

Definition at line 102 of file OgreGLHardwareOcclusionQuery.h.

The documentation for this class was generated from the following file:

- OgreGLHardwareOcclusionQuery.h

Copyright © 2012 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun Sep 2 2012 07:27:52